Attribute VB_Name = "basCollation"
Option Explicit

Private Const COLLATION_PATH As String = ":memory:" 'C

Private lngCollateCnt As Long
Private lngCollateNeededCnt As Long

Private Function collate_locale(ByRef lngArg As Long, ByVal lngALen As Long, ByVal lngpA As Long, ByVal lngBLen As Long, ByVal lngpB As Long) As Long
    Dim strA As String
    Dim strB As String
    
    'R[񐔉Z
    lngArg = lngArg + 1
    
    'r擾
    strA = UTF8toUTF16(lngpA, lngALen)
    strB = UTF8toUTF16(lngpB, lngBLen)
    'Debug.Print "collate_locale#" & CStr(lngArg), lngALen, strA, lngBLen, strB
    
    'VBStrComp֐ɂr
    collate_locale = StrComp(strA, strB, vbTextCompare)
    
    If collate_locale < 0 Then
        Debug.Print "collate_locale#" & CStr(lngArg), strA & " < " & strB
    ElseIf collate_locale > 0 Then
        Debug.Print "collate_locale#" & CStr(lngArg), strA & " > " & strB
    Else
        Debug.Print "collate_locale#" & CStr(lngArg), strA & " = " & strB
    End If
End Function

Private Sub collate_needed(ByRef lngCollNeededArg As Long, ByVal lngDB As Long, ByVal lngEncode As Long, ByVal lngCollate As Long)
    Dim lngRtnCd As Long
    Dim strCollate As String
    
    'R[񐔉Z
    lngCollNeededArg = lngCollNeededArg + 1
    
    'ORDER BY xxx COLLATE yyy yyy̕擾
    strCollate = UTF8toUTF16(lngCollate)
    Debug.Print "collate_needed#" & CStr(lngCollNeededArg), lngEncode, strCollate
    
    'GR[hyyy`FbN
    If lngEncode <> SQLITE_UTF8 Or UCase(strCollate) <> "LOCALE" Then Exit Sub
    
    'R[^쐬
    lngRtnCd = sqlite3std_create_collation(lngDB, "LOCALE", SQLITE_UTF8, lngCollateCnt, AddressOf collate_locale)
    Debug.Print "sqlite3std_create_collation", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "create_collation sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
    End If
    
End Sub

Private Function exec_callback(ByRef lngArg As Long, ByVal lngColNum As Long, ByVal lngppCol As Long, ByVal lngppName As Long) As Long
    Dim lngCnt As Long
    Dim lngpCol() As Long
    Dim lngpName() As Long
    
    'Jƒl擾
    ReDim lngpCol(lngColNum - 1)
    ReDim lngpName(lngColNum - 1)
    Call MoveMemory(lngpCol(0), ByVal lngppCol, lngColNum * 4)
    Call MoveMemory(lngpName(0), ByVal lngppName, lngColNum * 4)
    
    'R[񐔉Z
    lngArg = lngArg + 1
    Debug.Print "exec_callback#" & CStr(lngArg)
    
    For lngCnt = 0 To lngColNum - 1
        Debug.Print UTF8toUTF16(lngpName(lngCnt)) & "=" & UTF8toUTF16(lngpCol(lngCnt))
    Next
    
    exec_callback = SQLITE_OK
End Function

Public Sub sampleCollation()
    Dim lngRtnCd As Long
    Dim lngDB As Long
    Dim lngCnt As Long
    Dim lngArg As Long
    Dim bytSQL() As Byte
    Dim strSQL(6) As String
    strSQL(0) = "DROP TABLE IF EXISTS jisho;"
    strSQL(1) = "CREATE TABLE jisho ( word TEXT );"
    strSQL(2) = "INSERT INTO jisho ( word ) VALUES ( 'ng' );"
    strSQL(3) = "INSERT INTO jisho ( word ) VALUES ( 'p[g' );"
    strSQL(4) = "INSERT INTO jisho ( word ) VALUES ( 'n[g' );"
    strSQL(5) = "INSERT INTO jisho ( word ) VALUES ( 'o[h' );"
    strSQL(6) = "INSERT INTO jisho ( word ) VALUES ( '͂' );"
    'Const SQLSELECT As String = "SELECT * FROM jisho ORDER BY 1;"
    Const SQLSELECT As String = "SELECT * FROM jisho ORDER BY 1 COLLATE locale;"
    lngDB = 0
    lngArg = 0
    lngCollateCnt = 0
   
    'I[v
    lngRtnCd = sqlite3std_open_v2(COLLATION_PATH, lngDB, SQLITE_OPEN_CREATE Or SQLITE_OPEN_READWRITE, vbNullString)
    Debug.Print "sqlite3std_open_v2", lngRtnCd, lngDB
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "open sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_exit
    End If

    'e[u폜Ae[u쐬Af[^ǉ
    For lngCnt = 0 To UBound(strSQL)
        lngRtnCd = sqlite3std_exec_UTF8(lngDB, UTF16toUTF8(strSQL(lngCnt), bytSQL), 0, ByVal 0, ByVal 0)
        Debug.Print "sqlite3std_exec#" & CStr(lngCnt), lngRtnCd
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    Next
    
    'R[^쐬
    lngRtnCd = sqlite3std_collation_needed(lngDB, lngCollateNeededCnt, AddressOf collate_needed)
    Debug.Print "sqlite3std_collation_needed", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "collation_needed sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    '
    lngRtnCd = sqlite3std_exec(lngDB, SQLSELECT, AddressOf exec_callback, lngArg, ByVal 0)
    Debug.Print "SQLSELECT sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
lbl_close:
    If lngDB <> 0 Then Call sqlite3std_close(lngDB)
lbl_exit:
End Sub

