Attribute VB_Name = "basHook"
Option Explicit

Private Const HOOK_PATH As String = ":memory:" 'C


Private Sub update_hook_callback(ByRef lngpArg As Long, ByVal lngType As Long, ByVal lngDatabase As Long, _
    ByVal lngTable As Long, ByVal curRowId As Currency)
    lngpArg = lngpArg + 1
    Debug.Print "update_hook_callback#" & CStr(lngpArg), lngType, UTF8toUTF16(lngDatabase), UTF8toUTF16(lngTable), curRowId * 10000
End Sub

Private Function commit_hook_callback(ByRef lngpArg As Long) As Long
    lngpArg = lngpArg + 1
    Debug.Print "commit_hook_callback#" & CStr(lngpArg)
    commit_hook_callback = 0 'R~bgp
    'commit_hook_callback = 1 'R~bg~
End Function

Private Sub rollback_hook_callback(ByRef lngpArg As Long)
    lngpArg = lngpArg + 1
    Debug.Print "rollback_hook_callback#" & CStr(lngpArg)
End Sub

Private Function exec_callback(ByRef lngArg As Long, ByVal lngColNum As Long, ByVal lngppCol As Long, ByVal lngppName As Long) As Long
    Dim lngCnt As Long
    Dim lngpCol() As Long
    Dim lngpName() As Long
    
    'Jƒl擾
    ReDim lngpCol(lngColNum - 1)
    ReDim lngpName(lngColNum - 1)
    Call MoveMemory(lngpCol(0), ByVal lngppCol, lngColNum * 4)
    Call MoveMemory(lngpName(0), ByVal lngppName, lngColNum * 4)
    
    'R[񐔉Z
    lngArg = lngArg + 1
    Debug.Print "exec_callback#" & CStr(lngArg)
    
    For lngCnt = 0 To lngColNum - 1
        Debug.Print UTF8toUTF16(lngpName(lngCnt)) & "=" & UTF8toUTF16(lngpCol(lngCnt))
    Next
    
    exec_callback = SQLITE_OK
End Function

Public Sub sampleHook()
    Dim lngRtnCd As Long
    Dim lngDB As Long
    Dim lngCnt As Long
    Dim lngArg As Long 'exec_callbackR[
    Dim lngUpdateCnt As Long 'update_hook_callbackR[
    Dim lngCommitCnt As Long 'commit_hook_callbackR[
    Dim lngRollbackCnt As Long 'rollback_hook_callbackR[
    Dim strSQL(4) As String
    strSQL(0) = "DROP TABLE IF EXISTS sample;"
    strSQL(1) = "CREATE TABLE sample ( data INTEGER );"
    strSQL(2) = "INSERT INTO sample ( data ) VALUES ( 100 );"
    strSQL(3) = "INSERT INTO sample ( data ) VALUES ( 1000 );"
    strSQL(4) = "INSERT INTO sample ( data ) VALUES ( 10000 );"
    Const SQL_UPDATE As String = "UPDATE sample SET data = data * 2;"
    Const SQL_SELECT As String = "SELECT data FROM sample;"
    lngDB = 0
    lngArg = 0
    lngUpdateCnt = 0
    lngCommitCnt = 0
    lngRollbackCnt = 0
    
    'I[v
    lngRtnCd = sqlite3std_open_v2(HOOK_PATH, lngDB, SQLITE_OPEN_CREATE Or SQLITE_OPEN_READWRITE, vbNullString)
    Debug.Print "sqlite3std_open_v2", lngRtnCd, lngDB
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "open sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_exit
    End If

    'e[u폜Ae[u쐬Af[^ǉ
    For lngCnt = 0 To UBound(strSQL)
        lngRtnCd = sqlite3std_exec(lngDB, strSQL(lngCnt), 0, ByVal 0, ByVal 0)
        Debug.Print "sqlite3std_exec#" & CStr(lngCnt), lngRtnCd
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    Next
    
    'XVtbNݒ
    lngRtnCd = sqlite3std_update_hook(lngDB, AddressOf update_hook_callback, lngUpdateCnt)
    Debug.Print "sqlite3std_update_hook", lngRtnCd
    
    'R~bgtbNݒ
    lngRtnCd = sqlite3std_commit_hook(lngDB, AddressOf commit_hook_callback, lngCommitCnt)
    Debug.Print "sqlite3std_commit_hook", lngRtnCd
    
    '[obNtbNݒ
    lngRtnCd = sqlite3std_rollback_hook(lngDB, AddressOf rollback_hook_callback, lngRollbackCnt)
    Debug.Print "sqlite3std_rollback_hook", lngRtnCd
    
    'gUNVJn
    lngRtnCd = sqlite3std_exec(lngDB, "BEGIN;", 0, ByVal 0, ByVal 0)
    Debug.Print "BEGIN sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "BEGIN exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    'XV
    lngRtnCd = sqlite3std_exec(lngDB, SQL_UPDATE, 0, ByVal 0, ByVal 0)
    Debug.Print "UPDATE sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "UPDATE exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    'gUNVR~bg
    lngRtnCd = sqlite3std_exec(lngDB, "COMMIT;", 0, ByVal 0, ByVal 0)
    Debug.Print "COMMIT sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK And lngRtnCd <> SQLITE_CONSTRAINT Then
        Debug.Print "COMMIT exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
   
    'gUNVJn
    lngRtnCd = sqlite3std_exec(lngDB, "BEGIN;", 0, ByVal 0, ByVal 0)
    Debug.Print "BEGIN sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "BEGIN exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    'XV
    lngRtnCd = sqlite3std_exec(lngDB, SQL_UPDATE, 0, ByVal 0, ByVal 0)
    Debug.Print "UPDATE sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "UPDATE exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    'gUNV[obN
    lngRtnCd = sqlite3std_exec(lngDB, "ROLLBACK;", 0, ByVal 0, ByVal 0)
    Debug.Print "ROLLBACK sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "ROLLBACK exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    '
    lngRtnCd = sqlite3std_exec(lngDB, SQL_SELECT, AddressOf exec_callback, lngArg, ByVal 0)
    Debug.Print "SELECT sqlite3std_exec", lngRtnCd
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "SELECT exec sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
lbl_close:
    If lngDB <> 0 Then Call sqlite3std_close(lngDB)
lbl_exit:
End Sub


