Attribute VB_Name = "basPrepareStep"
Option Explicit

Private Const STEPPATH As String = ":memory:" 'C

Private Type typSample
    strVal As String
    lngVal As Long
    dblVal As Double
    bytVal(4) As Byte
End Type

Public Sub samplePrepareStep()
    Dim lngRtnCd As Long
    Dim lngDB As Long
    Dim lngpStmt As Long
    Dim lngCnt As Long
    Dim lngColNum As Long
    
    Const SQL_DROP As String = "DROP TABLE IF EXISTS sample;"
    Const SQL_CREATE As String = "CREATE TABLE sample ( txtval TEXT, ival INT, rval REAL, bval BLOB, nlval TEXT );"
    Const SQL_INSERT As String = "INSERT INTO sample ( txtval, ival, rval, bval, nlval ) VALUES ( ?1, ?2, ?3, ?4, ?5 );"
    Const SQL_SELECT As String = "SELECT * FROM sample;"

    Dim udtSample(2) As typSample
    udtSample(0).strVal = "": udtSample(0).lngVal = 123: udtSample(0).dblVal = 1.2345
    udtSample(0).bytVal(0) = &H11: udtSample(0).bytVal(1) = &H22: udtSample(0).bytVal(2) = &H33
    udtSample(0).bytVal(3) = &H44: udtSample(0).bytVal(4) = &H55
    udtSample(1).strVal = "": udtSample(1).lngVal = 456: udtSample(1).dblVal = 2.3456
    udtSample(1).bytVal(0) = &HAA: udtSample(1).bytVal(1) = &HBB: udtSample(1).bytVal(2) = &HCC
    udtSample(1).bytVal(3) = &HDD: udtSample(1).bytVal(4) = &HEE
    udtSample(2).strVal = "": udtSample(2).lngVal = 789: udtSample(2).dblVal = 3.4567
    udtSample(2).bytVal(0) = &H99: udtSample(2).bytVal(1) = &H0: udtSample(2).bytVal(2) = &H0
    udtSample(2).bytVal(3) = &H0: udtSample(2).bytVal(4) = &H88
    lngDB = 0
    lngpStmt = 0
    
    'I[v
    lngRtnCd = sqlite3std_open_v2(STEPPATH, lngDB, SQLITE_OPEN_CREATE Or SQLITE_OPEN_READWRITE, vbNullString)
    Debug.Print "sqlite3std_open_v2", lngRtnCd, lngDB
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "open sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_exit
    End If
    
    'e[u폜
    lngRtnCd = sqlite3std_prepare_v2(lngDB, SQL_DROP, -1, lngpStmt, ByVal 0)
    Debug.Print "sqlite3std_prepare_v2", lngRtnCd, lngpStmt
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "prepare_v2 sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    lngRtnCd = sqlite3std_step(lngpStmt)
    Debug.Print "sqlite3std_step", lngRtnCd
    If lngRtnCd <> SQLITE_DONE Then
        Debug.Print "step sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    lngRtnCd = sqlite3std_finalize(lngpStmt)
    Debug.Print "sqlite3std_finalize", lngRtnCd
    
    'e[u쐬
    lngRtnCd = sqlite3std_prepare_v2(lngDB, SQL_CREATE, -1, lngpStmt, ByVal 0)
    Debug.Print "sqlite3std_prepare_v2", lngRtnCd, lngpStmt
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "prepare_v2 sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    lngRtnCd = sqlite3std_step(lngpStmt)
    Debug.Print "sqlite3std_step", lngRtnCd
    If lngRtnCd <> SQLITE_DONE Then
        Debug.Print "step sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    lngRtnCd = sqlite3std_finalize(lngpStmt)
    Debug.Print "sqlite3std_finalize", lngRtnCd
    
    'f[^}
    lngRtnCd = sqlite3std_prepare_v2(lngDB, SQL_INSERT, -1, lngpStmt, ByVal 0)
    Debug.Print "sqlite3std_prepare_v2", lngRtnCd, lngpStmt
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "prepare_v2 sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    For lngCnt = 0 To UBound(udtSample)
    
        lngRtnCd = sqlite3std_clear_bindings(lngpStmt)
        Debug.Print "sqlite3std_clear_bindings", lngRtnCd
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "clear_binding sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
        
        'Shift-JIS
        lngRtnCd = sqlite3std_bind_text(lngpStmt, 1, udtSample(lngCnt).strVal, -1, SQLITE_STATIC)
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "bind_text sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
            
        '
        lngRtnCd = sqlite3std_bind_int(lngpStmt, 2, udtSample(lngCnt).lngVal)
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "bind_int sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    
        '
        lngRtnCd = sqlite3std_bind_double(lngpStmt, 3, udtSample(lngCnt).dblVal)
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "bind_double sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
   
        'BLOB
        lngRtnCd = sqlite3std_bind_blob(lngpStmt, 4, udtSample(lngCnt).bytVal(0), UBound(udtSample(lngCnt).bytVal) + 1, SQLITE_STATIC)
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "bind_blob sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    
        'null
        lngRtnCd = sqlite3std_bind_null(lngpStmt, 5)
        If lngRtnCd <> SQLITE_OK Then
            Debug.Print "bind_null sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
    
        lngRtnCd = sqlite3std_step(lngpStmt)
        Debug.Print "sqlite3std_step", lngRtnCd
        If lngRtnCd <> SQLITE_DONE Then
            Debug.Print "step sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
            GoTo lbl_close
        End If
        
        lngRtnCd = sqlite3std_reset(lngpStmt)
        Debug.Print "sqlite3std_reset", lngRtnCd
    
    Next
    
    lngRtnCd = sqlite3std_finalize(lngpStmt)
    Debug.Print "sqlite3std_finalize", lngRtnCd
    
    '
    lngRtnCd = sqlite3std_prepare_v2(lngDB, SQL_SELECT, -1, lngpStmt, ByVal 0)
    Debug.Print "sqlite3std_prepare_v2", lngRtnCd, lngpStmt
    If lngRtnCd <> SQLITE_OK Then
        Debug.Print "prepare_v2 sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
    Do
        lngRtnCd = sqlite3std_step(lngpStmt)
        Debug.Print "sqlite3std_step", lngRtnCd
        
        If lngRtnCd <> SQLITE_ROW Then Exit Do
    
        lngColNum = sqlite3std_column_count(lngpStmt)
        For lngCnt = 0 To lngColNum - 1
            Select Case sqlite3std_column_type(lngpStmt, lngCnt)
            Case SQLITE_INTEGER
                Debug.Print UTF8toUTF16(sqlite3std_column_name(lngpStmt, lngCnt)) & "=" _
                    & CStr(sqlite3std_column_int(lngpStmt, lngCnt))
            Case SQLITE3_TEXT
                Debug.Print UTF8toUTF16(sqlite3std_column_name(lngpStmt, lngCnt)) & "=" _
                    & ShiftJIStoUTF16(sqlite3std_column_text(lngpStmt, lngCnt))
            Case SQLITE_FLOAT
                Debug.Print UTF8toUTF16(sqlite3std_column_name(lngpStmt, lngCnt)) & "=" _
                    & CStr(sqlite3std_column_double(lngpStmt, lngCnt))
            Case SQLITE_BLOB
                Debug.Print UTF8toUTF16(sqlite3std_column_name(lngpStmt, lngCnt)) & "=" _
                    & getBLOB(sqlite3std_column_blob(lngpStmt, lngCnt), sqlite3std_column_bytes(lngpStmt, lngCnt))
            Case SQLITE_NULL
                Debug.Print UTF8toUTF16(sqlite3std_column_name(lngpStmt, lngCnt)) & "=(null)"
            End Select
        Next
    Loop
    
    If lngRtnCd <> SQLITE_DONE Then
        Debug.Print "step sqlite3std_errmsg", UTF8toUTF16(sqlite3std_errmsg(lngDB))
        GoTo lbl_close
    End If
    
lbl_close:
    If lngpStmt <> 0 Then Call sqlite3std_finalize(lngpStmt)
    If lngDB <> 0 Then Call sqlite3std_close(lngDB)
lbl_exit:
End Sub


