Attribute VB_Name = "basSQLite3std"
Option Explicit

Public Const SQLITE_OK          As Long = 0    'Successful result
Public Const SQLITE_ERROR       As Long = 1    'SQL error or missing database
Public Const SQLITE_INTERNAL    As Long = 2    'Internal logic error in SQLite
Public Const SQLITE_PERM        As Long = 3    'Access permission denied
Public Const SQLITE_ABORT       As Long = 4    'Callback routine requested an abort
Public Const SQLITE_BUSY        As Long = 5    'The database file is locked
Public Const SQLITE_LOCKED      As Long = 6    'A table in the database is locked
Public Const SQLITE_NOMEM       As Long = 7    'A malloc() failed
Public Const SQLITE_READONLY    As Long = 8    'Attempt to write a readonly database
Public Const SQLITE_INTERRUPT   As Long = 9    'Operation terminated by sqlite3_interrupt()
Public Const SQLITE_IOERR       As Long = 10   'Some kind of disk I/O error occurred
Public Const SQLITE_CORRUPT     As Long = 11   'The database disk image is malformed
Public Const SQLITE_NOTFOUND    As Long = 12   'NOT USED. Table or record not found
Public Const SQLITE_FULL        As Long = 13   'Insertion failed because database is full
Public Const SQLITE_CANTOPEN    As Long = 14   'Unable to open the database file
Public Const SQLITE_PROTOCOL    As Long = 15   'Database lock protocol error
Public Const SQLITE_EMPTY       As Long = 16   'Database is empty
Public Const SQLITE_SCHEMA      As Long = 17   'The database schema changed
Public Const SQLITE_TOOBIG      As Long = 18   'String or BLOB exceeds size limit
Public Const SQLITE_CONSTRAINT  As Long = 19   'Abort due to constraint violation
Public Const SQLITE_MISMATCH    As Long = 20   'Data type mismatch
Public Const SQLITE_MISUSE      As Long = 21   'Library used incorrectly
Public Const SQLITE_NOLFS       As Long = 22   'Uses OS features not supported on host
Public Const SQLITE_AUTH        As Long = 23   'Authorization denied
Public Const SQLITE_FORMAT      As Long = 24   'Auxiliary database format error
Public Const SQLITE_RANGE       As Long = 25   '2nd parameter to sqlite3_bind out of range
Public Const SQLITE_NOTADB      As Long = 26   'File opened that is not a database file
Public Const SQLITE_ROW         As Long = 100  'sqlite3_step() has another row ready
Public Const SQLITE_DONE        As Long = 101  'sqlite3_step() has finished executing

Public Const SQLITE_OPEN_READONLY         As Long = &H1         'Ok for sqlite3_open_v2()
Public Const SQLITE_OPEN_READWRITE        As Long = &H2         'Ok for sqlite3_open_v2()
Public Const SQLITE_OPEN_CREATE           As Long = &H4         'Ok for sqlite3_open_v2()
Public Const SQLITE_OPEN_DELETEONCLOSE    As Long = &H8         'VFS only
Public Const SQLITE_OPEN_EXCLUSIVE        As Long = &H10        'VFS only
Public Const SQLITE_OPEN_AUTOPROXY        As Long = &H20        'VFS only
Public Const SQLITE_OPEN_MAIN_DB          As Long = &H100       'VFS only
Public Const SQLITE_OPEN_TEMP_DB          As Long = &H200       'VFS only
Public Const SQLITE_OPEN_TRANSIENT_DB     As Long = &H400       'VFS only
Public Const SQLITE_OPEN_MAIN_JOURNAL     As Long = &H800       'VFS only
Public Const SQLITE_OPEN_TEMP_JOURNAL     As Long = &H1000      'VFS only
Public Const SQLITE_OPEN_SUBJOURNAL       As Long = &H2000      'VFS only
Public Const SQLITE_OPEN_MASTER_JOURNAL   As Long = &H4000      'VFS only
Public Const SQLITE_OPEN_NOMUTEX          As Long = &H8000      'Ok for sqlite3_open_v2()
Public Const SQLITE_OPEN_FULLMUTEX        As Long = &H10000     'Ok for sqlite3_open_v2()
Public Const SQLITE_OPEN_SHAREDCACHE      As Long = &H20000     'Ok for sqlite3_open_v2()
Public Const SQLITE_OPEN_PRIVATECACHE     As Long = &H40000     'Ok for sqlite3_open_v2()
Public Const SQLITE_OPEN_WAL              As Long = &H80000     'VFS only

Public Const SQLITE_STATIC      As Long = 0
Public Const SQLITE_TRANSIENT   As Long = -1

Public Const SQLITE_INTEGER  As Long = 1
Public Const SQLITE_FLOAT    As Long = 2
Public Const SQLITE_TEXT     As Long = 3
Public Const SQLITE3_TEXT    As Long = 3
Public Const SQLITE_BLOB     As Long = 4
Public Const SQLITE_NULL     As Long = 5

Public Const SQLITE_CREATE_INDEX         As Long = 1    'Index Name      Table Name
Public Const SQLITE_CREATE_TABLE         As Long = 2    'Table Name      NULL
Public Const SQLITE_CREATE_TEMP_INDEX    As Long = 3    'Index Name      Table Name
Public Const SQLITE_CREATE_TEMP_TABLE    As Long = 4    'Table Name      NULL
Public Const SQLITE_CREATE_TEMP_TRIGGER  As Long = 5    'Trigger Name    Table Name
Public Const SQLITE_CREATE_TEMP_VIEW     As Long = 6    'View Name       NULL
Public Const SQLITE_CREATE_TRIGGER       As Long = 7    'Trigger Name    Table Name
Public Const SQLITE_CREATE_VIEW          As Long = 8    'View Name       NULL
Public Const SQLITE_DELETE               As Long = 9    'Table Name      NULL
Public Const SQLITE_DROP_INDEX           As Long = 10   'Index Name      Table Name
Public Const SQLITE_DROP_TABLE           As Long = 11   'Table Name      NULL
Public Const SQLITE_DROP_TEMP_INDEX      As Long = 12   'Index Name      Table Name
Public Const SQLITE_DROP_TEMP_TABLE      As Long = 13   'Table Name      NULL
Public Const SQLITE_DROP_TEMP_TRIGGER    As Long = 14   'Trigger Name    Table Name
Public Const SQLITE_DROP_TEMP_VIEW       As Long = 15   'View Name       NULL
Public Const SQLITE_DROP_TRIGGER         As Long = 16   'Trigger Name    Table Name
Public Const SQLITE_DROP_VIEW            As Long = 17   'View Name       NULL
Public Const SQLITE_INSERT               As Long = 18   'Table Name      NULL
Public Const SQLITE_PRAGMA               As Long = 19   'Pragma Name     1st arg or NULL
Public Const SQLITE_READ                 As Long = 20   'Table Name      Column Name
Public Const SQLITE_SELECT               As Long = 21   'NULL            NULL
Public Const SQLITE_TRANSACTION          As Long = 22   'Operation       NULL
Public Const SQLITE_UPDATE               As Long = 23   'Table Name      Column Name
Public Const SQLITE_ATTACH               As Long = 24   'Filename        NULL
Public Const SQLITE_DETACH               As Long = 25   'Database Name   NULL
Public Const SQLITE_ALTER_TABLE          As Long = 26   'Database Name   Table Name
Public Const SQLITE_REINDEX              As Long = 27   'Index Name      NULL
Public Const SQLITE_ANALYZE              As Long = 28   'Table Name      NULL
Public Const SQLITE_CREATE_VTABLE        As Long = 29   'Table Name      Module Name
Public Const SQLITE_DROP_VTABLE          As Long = 30   'Table Name      Module Name
Public Const SQLITE_FUNCTION             As Long = 31   'NULL            Function Name
Public Const SQLITE_SAVEPOINT            As Long = 32   'Operation       Savepoint Name
Public Const SQLITE_COPY                 As Long = 0    'No longer used

Public Const SQLITE_UTF8           As Long = 1
Public Const SQLITE_UTF16LE        As Long = 2
Public Const SQLITE_UTF16BE        As Long = 3
Public Const SQLITE_UTF16          As Long = 4    'Use native byte order
Public Const SQLITE_ANY            As Long = 5    'sqlite3_create_function only
Public Const SQLITE_UTF16_ALIGNED  As Long = 8    'sqlite3_create_collation only


Public Declare Function sqlite3std_open Lib "SQLite3std.dll" ( _
    ByVal filename As String, _
    ByRef db As Long _
) As Long

Public Declare Function sqlite3std_open_v2 Lib "SQLite3std.dll" ( _
    ByVal filename As String, _
    ByRef db As Long, _
    ByVal flags As Long, _
    ByVal zVfs As String _
) As Long

Public Declare Sub sqlite3std_close Lib "SQLite3std.dll" ( _
    ByVal db As Long _
)

Public Declare Function sqlite3std_get_table Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal zSql As String, _
    ByRef pazResult As Long, _
    ByRef pnRow As Long, _
    ByRef pnColumn As Long, _
    ByRef pzErrmsg As Long _
) As Long

Public Declare Function sqlite3std_exec Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal zSql As String, _
    ByVal xCallback As Long, _
    ByRef pArg As Long, _
    ByRef pzErrmsg As Long _
) As Long

Public Declare Function sqlite3std_exec_UTF8 Lib "SQLite3std.dll" Alias "sqlite3std_exec" ( _
    ByVal db As Long, _
    ByVal zSql As Long, _
    ByVal xCallback As Long, _
    ByRef pArg As Long, _
    ByRef pzErrmsg As Long _
) As Long

Public Declare Sub sqlite3std_free Lib "SQLite3std.dll" ( _
    ByVal p As Long _
)

Public Declare Sub sqlite3std_free_table Lib "SQLite3std.dll" ( _
    ByVal result As Long _
)

Public Declare Function sqlite3std_errcode Lib "SQLite3std.dll" ( _
    ByVal db As Long _
) As Long

Public Declare Function sqlite3std_errmsg Lib "SQLite3std.dll" ( _
    ByVal db As Long _
) As Long

Public Declare Function sqlite3std_finalize Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long _
) As Long

Public Declare Function sqlite3std_prepare_v2 Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal zSql As String, _
    ByVal nByte As Long, _
    ByRef ppStmt As Long, _
    ByRef pzTail As Long _
) As Long

Public Declare Function sqlite3std_step Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long _
) As Long

Public Declare Function sqlite3std_sql Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long _
) As Long

Public Declare Function sqlite3std_stmt_readonly Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long _
) As Long

Public Declare Function sqlite3std_clear_bindings Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long _
) As Long

Public Declare Function sqlite3std_bind_text Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long, _
    ByVal zData As String, _
    ByVal nData As Long, _
    ByVal xDel As Long _
) As Long

Public Declare Function sqlite3std_bind_int Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long, _
    ByVal iValue As Long _
) As Long

Public Declare Function sqlite3std_bind_double Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long, _
    ByVal rValue As Double _
) As Long

Public Declare Function sqlite3std_bind_blob Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long, _
    ByRef zData As Any, _
    ByVal nData As Long, _
    ByVal xDel As Long _
) As Long

Public Declare Function sqlite3std_bind_null Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long _
) As Long

Public Declare Function sqlite3std_reset Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long _
) As Long

Public Declare Function sqlite3std_bind_parameter_index Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal zName As String _
) As Long

Public Declare Function sqlite3std_column_count Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long _
) As Long

Public Declare Function sqlite3std_column_type Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long _
) As Long

Public Declare Function sqlite3std_column_text Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long _
) As Long

Public Declare Function sqlite3std_column_int Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long _
) As Long

Public Declare Function sqlite3std_column_double Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long _
) As Double

Public Declare Function sqlite3std_column_blob Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long _
) As Long

Public Declare Function sqlite3std_column_bytes Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal i As Long _
) As Long

Public Declare Function sqlite3std_column_name Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal n As Long _
) As Long

Public Declare Function sqlite3std_column_decltype Lib "SQLite3std.dll" ( _
    ByVal pStmt As Long, _
    ByVal n As Long _
) As Long

Public Declare Function sqlite3std_commit_hook Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal xCallback As Long, _
    ByRef pArg As Long _
) As Long

Public Declare Function sqlite3std_update_hook Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal xCallback As Long, _
    ByRef pArg As Long _
) As Long

Public Declare Function sqlite3std_rollback_hook Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal xCallback As Long, _
    ByRef pArg As Long _
) As Long

Public Declare Function sqlite3std_create_collation Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal zName As String, _
    ByVal enc As Long, _
    ByRef pCtx As Long, _
    ByVal xCompare As Long _
) As Long

Public Declare Function sqlite3std_collation_needed Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByRef pCollNeededArg As Long, _
    ByVal xCollNeeded As Long _
) As Long

Public Declare Function sqlite3std_create_function Lib "SQLite3std.dll" ( _
    ByVal db As Long, _
    ByVal zFunctionName As String, _
    ByVal nArg As Long, _
    ByVal eTextRep As Long, _
    ByRef pApp As Long, _
    ByVal xFunc As Long, _
    ByVal xStep As Long, _
    ByVal xFinal As Long _
) As Long

Public Declare Function sqlite3std_user_data Lib "SQLite3std.dll" ( _
    ByVal p As Long _
) As Long

Public Declare Function sqlite3std_value_int Lib "SQLite3std.dll" ( _
    ByVal pVal As Long _
) As Long

Public Declare Function sqlite3std_value_text Lib "SQLite3std.dll" ( _
    ByVal pVal As Long _
) As Long

Public Declare Sub sqlite3std_result_text Lib "SQLite3std.dll" ( _
    ByVal pCtx As Long, _
    ByVal z As String, _
    ByVal n As Long, _
    ByVal xDel As Long _
)

Public Declare Sub sqlite3std_result_text_UTF8 Lib "SQLite3std.dll" Alias "sqlite3std_result_text" ( _
    ByVal pCtx As Long, _
    ByVal z As Long, _
    ByVal n As Long, _
    ByVal xDel As Long _
)

Public Declare Function sqlite3std_aggregate_context Lib "SQLite3std.dll" ( _
    ByVal p As Long, _
    ByVal nByte As Long _
) As Long

Public Declare Sub sqlite3std_result_int Lib "SQLite3std.dll" ( _
    ByVal pCtx As Long, _
    ByVal iVal As Long _
)






